#ifndef __LCL_PHYOPERATIONS_H___
#define __LCL_PHYOPERATIONS_H___

#include<stdarg.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "xmlutils.h"
#include "phy_operations.h"

#define PHY_FHSS		1
#define PHY_DSSS		2
#define PHY_IRBASEBAND		3

#define PHY_TEMP_TYPE_1		1
#define PHY_TEMP_TYPE_2		2

/* columns present in station config tables */
#define PHY_OPERATION_PHY_TYPE          "dot11-phy-type"
#define PHY_OPERATION_CURR_REG_DOMAIN   "dot11-current-reg-domain"
#define PHY_OPERATION_TEMP_TYPE         "dot11-temp-type"

struct phy_oper_data_info {
	char *phy_type;
	int phy_type_len;
	char *curr_reg_domain;
	int curr_reg_domain_len;
	char *temp_type;
	int temp_type_len;
};

static int CheckAndRetrievePhyType(xmlDocPtr);
static int CheckAndRetrieveCurrentRegDomain(xmlDocPtr);
static int CheckAndRetrieveTempType(xmlDocPtr);

static void lcl_phy_type_xml(xmlDocPtr, xmlNodePtr);
static void lcl_current_reg_domain_xml(xmlDocPtr, xmlNodePtr);
static void lcl_temp_type_xml(xmlDocPtr, xmlNodePtr);

static void GetPhyType(xmlDocPtr, int);
static void GetCurrentRegDomain(xmlDocPtr, int);
static void GetTempType(xmlDocPtr, int);
#endif  /* __LCL_PHYOPERATIONS_H__*/
