/* header file for apconf query api */

#ifndef _apconf_query_h_
#define _apconf_query_h_ 1
 
#ifndef DBG
#define DBG(x, args...) do { \
	static FILE *console = NULL; \
	if (!console) { \
		console = fopen("/dev/console", "w"); \
	} \
	fprintf(console, "%s %d: " x, __FILE__, __LINE__, ##args); \
} while (0)
#endif


//#include <util/neo_hdf.h>
//#include "int.h"

typedef struct _apconf_table {
	char *objectname;  // Name of table (or object type)
	char **fieldnames; // Ordered list of fields.
	int numfields; // Number of fields (columns)
	char **results; // List of results.
	int rows;
} apconf_table;

typedef struct _apconf_object {
	char *type;
	char *name;
	int numfields;
	char ** fieldnames;
	char ** values;
} apconf_object;

// implemented
int  apconf_object_value( char *object_type, char *object_name,  char*content_element, char **value );

int apconf_object_update_value( char *object_type, char *object_name, char *content_element, char *value );

int apconf_update_object_value( char *object_type, char *object_name, char *content_element, char *value );

//int * apconf_object_value_ifpresent( char *object_type, char * object_name, char * content_element, char ** value );

//int * apconf_general_value( char *object_type, char*content_element, char **value );

//int * apconf_general_update_value( char *object_type, char *content_element, char *value );

//int * apconf_general_value_ifpresent( char *object_type, char *content_element, char **value );

//int * apconf_table_free_members( apconf_table *table );

//int * apconf_table_cell( apconf_table *table, int row, int column, char **value );

// implemented
//int * apconf_table_populate( apconf_table *table, HDF** hdf );

//int * apconf_table_populate_exclude( apconf_table *table, char *excludefield, char *withvalue, HDF** hdf );

int apconf_insert_object( apconf_object * object );

int apconf_update_object( apconf_object * object );

//int * apconf_retrieve_object( apconf_object * object );

//int * apconf_object_count( char *type, int *number );

int apconf_object_exists( apconf_object * object, int *rows );

int apconf_delete_object( apconf_object *object );

//int * apconf_save_running_config( void );

#endif
