#ifndef LSQLQUERY_CONNECTOR_H
#define LSQLQUERY_CONNECTOR_H 1

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

#include <lsqlquery/value.h>

/* The caller must set one or the other prior to using this library.
   If both are set, the x version takes precedence. */

typedef xmlDocPtr (*connector_xeval_lsql_t)(xmlDocPtr lsql_doc);
typedef char * (*connector_eval_lsql_t)(char * lsql);

extern connector_xeval_lsql_t connector_xeval_lsql;
extern connector_eval_lsql_t connector_eval_lsql;

char *apc_web_get_name(char *class,
		       apc_web_value_t *qualifier_values);

apc_web_value_t *apc_web_get_value(char *class,
				   char *instance,
				   char *field);

apc_web_value_t *apc_web_get_value_q(char *class,
				     char *instance,
				     char *field,
				     apc_web_value_t *qualifier_values);

apc_web_value_t *apc_web_get_value_q1(char *class,
				      char *instance,
				      char *field,
				      char *qproperty, char *qvalue);

apc_web_value_t *apc_web_get_table(char *class, ...);
#define NEW_TABLE_MARK "__NEW_TABLE__"
#define NEW_ROW_MARK "__NEW_ROW__"

apc_web_value_t *apc_web_get_grid(char *class,
				  char *instance,
				  apc_web_value_t *fields,
				  apc_web_value_t *qualifier_values,
				  int include_name);

int apc_web_set_value(char *class, char *instance, apc_web_value_t *value,
		      apc_web_value_t *qualifier_values);
int apc_web_set_value_with_error(char *class,
				 char *instance,
				 apc_web_value_t *value,
				 apc_web_value_t *qualifier_values,
				 char **error);
int apc_web_delete_value(char *class, char *instance,
			 apc_web_value_t *qualifier_values);
int apc_web_insert_value(const char *class, const char *instance,
			 const apc_web_value_t *value);
int apc_web_reset_value(char *class, char *instance, apc_web_value_t *value,
			apc_web_value_t *qualifier_values);

int apc_web_flush_set_value_queue(void);
int apc_web_queue_set_value(char *class, char *instance,
			    apc_web_value_t *value,
			    apc_web_value_t *qualifier_values);

#endif /* LSQLQUERY_CONNECTOR_H */
